﻿@page "/materialviewer"

@using AntDesign
@using System.ComponentModel
@using System.Text;
@using System.Net;
@using FIOWeb.Models
@using FIOWeb.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState
@inject IBlazorDbFactory DbFactory

<link href="./css/page-specific/GroupHub.css?lastup=20210425121800" rel="stylesheet" />
<link href="./css/materials.css?lastup=20210425121800" rel="stylesheet"/>

<FIOWeb.Components.LoadingWrapper @bind-ProgressCount="CurrentProgress" TotalProgress="3">
    <AutoComplete style="width:20%" @bind-Value="@UISelectedTicker" Options="@MaterialTickers" OnSelectionChange="OnSelectionChange" Placeholder="Ticker"/>
    <br/>
    @if (bLoadingTicker)
    {
        <br/>
        <Spin/>
    }
    @if (SelectedMaterial != null)
    {
        <Tabs>
            <TabPane Key="1" Tab="Exchange Info">
                <ChildContent>
                    @if (ExchangeOrderData == null)
                    {
                        <Spin/>
                    }
                    else
                    {
                        <div style="display:flex">
                            @foreach (var ExchangeOrder in ExchangeOrderData)
                            {
                                <table class="flights_table" style="margin-right:10px;">
                                    <tr>
                                        <th>@ExchangeOrder.MaterialTicker</th>
                                        <th>@ExchangeOrder.ExchangeCode</th>
                                        <th></th>
                                    </tr>
                                    <tr>
                                        <td>Average</td>
                                        <td>@(ExchangeOrder.PriceAverage != null ? ((double)ExchangeOrder.PriceAverage).ToString("N2") : "")</td>
                                    </tr>
                                    <tr>
                                        <td>Ask</td>
                                        <td>@(ExchangeOrder.Ask != null ? ((double)ExchangeOrder.Ask).ToString("N2") : "")</td>
                                    </tr>
                                    <tr>
                                        <td>Bid</td>
                                        <td>@(ExchangeOrder.Bid != null ? ((double)ExchangeOrder.Bid).ToString("N2") : "")</td>
                                    </tr>

                                    <tr></tr>

                                    <tr>
                                        <td colspan="3"><b>Offers</b></td>
                                    </tr>

                                    <tr>
                                        <td><em>Trader</em></td>
                                        <td><em>Amount</em></td>
                                        <td><em>Price</em></td>
                                    </tr>

                                    @foreach( var Order in ExchangeOrder.SellingOrders)
                                    {
                                        <tr>
                                            <td>@Order.CompanyName</td>
                                            <td>@(Order.ItemCount != null ? Order.ItemCount : "∞")</td>
                                            <td>@(((double)Order.ItemCost).ToString("N2"))</td>
                                        </tr>
                                    }

                                    <tr></tr>
                                    <tr>
                                        <td></td>  
                                        <td><b>Spread:</b></td>
                                        <td>@(ExchangeOrder.Spread != null ? ((double)ExchangeOrder.Spread).ToString("N2") : "")</td>
                                    </tr>
                                    <tr></tr>
                                    <tr>
                                        <td colspan="3"><b>Requests</b></td>
                                    </tr>   

                                    @foreach( var Order in ExchangeOrder.BuyingOrders)
                                    {
                                        <tr>
                                            <td>@Order.CompanyName</td>
                                            <td>@(Order.ItemCount != null ? Order.ItemCount : "∞")</td>
                                            <td>@(((double)Order.ItemCost).ToString("N2"))</td>
                                        </tr>
                                    }
                                </table>
                            }
                        </div>     
                    }
                </ChildContent>
            </TabPane>
            <TabPane Key="2" Tab="Material Info">
                <ChildContent>
                    <table class="flights_table">
                        <tr>
                            <th></th>
                            <th></th>
                        </tr>
                        <tr>
                            <td>Name</td>
                            <td>@SelectedMaterial.Name</td>
                        </tr>
                        <tr>
                            <td>Ticker</td>
                            <td>@SelectedMaterial.Ticker</td>
                        </tr>
                        <tr>
                            <td>Category</td>
                            <td>@SelectedMaterial.CategoryName</td>
                        </tr>
                        <tr>
                            <td>Weight</td>
                            <td>@SelectedMaterial.Weight</td>
                        </tr>
                        <tr>
                            <td>Volume</td>
                            <td>@SelectedMaterial.Volume</td>
                        </tr>
                        <tr>
                            <td>Production</td>
                            <td></td>
                        </tr>
                        @foreach(var TickerRecipe in TickerRecipeProduction)
                        {
                            <tr height="36px">
                              <td></td>
                              <td class="production-list">
                                  @foreach (var input in TickerRecipe.Inputs)
                                  {
                                      <span style="cursor:pointer" @onclick="@(async () => {UISelectedTicker = input.Ticker; await HandleNewTicker(input.Ticker);})" class="inventory_item @input.MaterialCSSCategory.ToLower()">
                                          <span class="inventory_amount">@input.Amount</span>
                                          <span class="inventory_ticker">@input.Ticker</span>
                                      </span>
                                  }
                                  <span class="building-at">@@</span>
                                  <span class="inventory_item building">
                                      <span class="inventory_ticker">@TickerRecipe.BuildingTicker</span>
                                  </span>
                                  <span class="inventory_item time">
                                      <span class="production_time">@TickerRecipe.TimeInHours</span>
                                  </span>
                                  @foreach (var output in TickerRecipe.Outputs)
                                  {
                                      <span style="cursor:pointer" @onclick="@(async () => {UISelectedTicker = output.Ticker; await HandleNewTicker(output.Ticker);})" class="inventory_item @output.MaterialCSSCategory.ToLower()">
                                          <span class="inventory_amount">@output.Amount</span>
                                          <span class="inventory_ticker">@output.Ticker</span>
                                      </span>
                                  }
                              </td>
                            </tr>
                        }
                        <tr>
                            <td>Wrought product</td>
                            <td></td>
                        </tr>
                        @foreach(var TickerRecipe in TickerRecipeWroughtProduct)
                        {
                            <tr height="36px">
                              <td></td>
                              <td class="production-list">
                                  @foreach (var input in TickerRecipe.Inputs)
                                  {
                                      <span style="cursor:pointer" @onclick="@(async () => {UISelectedTicker = input.Ticker; await HandleNewTicker(input.Ticker);})" class="inventory_item @input.MaterialCSSCategory.ToLower()">
                                          <span class="inventory_amount">@input.Amount</span>
                                          <span class="inventory_ticker">@input.Ticker</span>
                                      </span>
                                  }
                                  <span class="building-at">@@</span>
                                  <span class="inventory_item building">
                                      <span class="inventory_ticker">@TickerRecipe.BuildingTicker</span>
                                  </span>
                                  <span class="inventory_item time">
                                      <span class="production_time">@TickerRecipe.TimeInHours</span>
                                  </span>
                                  @foreach (var output in TickerRecipe.Outputs)
                                  {
                                      <span style="cursor:pointer" @onclick="@(async () => {UISelectedTicker = output.Ticker; await HandleNewTicker(output.Ticker);})" class="inventory_item @output.MaterialCSSCategory.ToLower()">
                                          <span class="inventory_amount">@output.Amount</span>
                                          <span class="inventory_ticker">@output.Ticker</span>
                                      </span>
                                  }
                              </td>
                            </tr>
                        }
                    </table>
                </ChildContent>
            </TabPane>
        </Tabs>
    }
</FIOWeb.Components.LoadingWrapper>